Multiscroll.Tool.Drag = function(parent) {
	this.parent = parent;	// to monitor clientX, clientY
};

Multiscroll.Tool.Drag.prototype = new Multiscroll.Tool({
	start : function(evt) {
		this.active = true;
		this.done = true;

		this.insertMarker(evt);
		window.setCursor(this.cursor);
	},
	stop : function(evt) {
		this.active = false;
		this.removeMarker(evt);
		window.setCursor("default");
	},
	execute : function(evt) {
		window.setCursor(this.cursor);
		var x = (this.startX - this.parent.event.clientX) * this.settings.multiplier;
		var y = (this.startY - this.parent.event.clientY) * this.settings.multiplier;
		x = x>0 ? Math.pow(Math.abs(x), this.settings.exponent) : x<0 ? -Math.pow(Math.abs(x), this.settings.exponent) : 0;
		y = y>0 ? Math.pow(Math.abs(y), this.settings.exponent) : y<0 ? -Math.pow(Math.abs(y), this.settings.exponent) : 0;
		this.startX = this.parent.event.clientX;
		this.startY = this.parent.event.clientY;
		this.scrollX += x;
		this.scrollY += y;
		this.client.frame.scrollTo(this.scrollX, this.scrollY);
		if (Math.abs(this.scrollX - this.client.frame.pageXOffset) > 10 )
			this.scrollX = this.client.frame.pageXOffset;
		if (Math.abs(this.scrollY - this.client.frame.pageYOffset) > 10 )
			this.scrollY = this.client.frame.pageYOffset;
		// retain sub-pixel movements but protect edges from exponential dragging
	},
	insertMarker : function(evt) {
		var left = evt.clientX;
		var top = evt.clientY;
		var imageWidth = 30;
		var imageHeight = 30;
	
		// marker
		var el = this.client.document.createElementNS("http://www.w3.org/1999/xhtml", "img");
		el.src = this.image;
	
		el.style.position = "fixed";
		el.style.left = left - imageWidth / 2 + "px";
		el.style.top = top - imageHeight / 2 + "px";
		el.style.width = imageWidth + "px";
		el.style.height = imageHeight + "px";
		el.style.cursor = this.cursor;
	
		this.client.body.appendChild(el);
	
		this.markerNode = el;
	},
	removeMarker : function() {
		if (this.markerNode != null)
			this.markerNode.parentNode.removeChild(this.markerNode);
	
		this.markerNode = null;
	}
});